// Simple example of a geometry shader with instancing

#version 410

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;
layout(invocations = 6) in;

out vec4 exColor;

void main()
{
  vec4 middleOfTriangle = vec4(0.0);
  vec4 v1,v2,v3;
  
  // Every triangle is split in 6 triangles
  // but only one is made by each instance.
  // Pretty stupid; no claims of good performance.
  
  switch (gl_InvocationID)
  {
  	case 0:
	  v1 = gl_in[0].gl_Position;
	  v2 = (gl_in[0].gl_Position*2 + gl_in[1].gl_Position)/3;
	  v3 = (gl_in[0].gl_Position*2 + gl_in[2].gl_Position)/3;
	  exColor = vec4(1,0,0,1);
	  break;
  	case 1:
	  v1 = (gl_in[0].gl_Position*2 + gl_in[1].gl_Position)/3;
	  v2 = (gl_in[0].gl_Position + gl_in[1].gl_Position*2)/3;
	  v3 = (gl_in[0].gl_Position + gl_in[1].gl_Position + gl_in[2].gl_Position)/3;
	  exColor = vec4(0,1,0,1);
	  break;
  	case 2:
	  v1 = (gl_in[0].gl_Position*2 + gl_in[2].gl_Position)/3;
	  v2 = (gl_in[0].gl_Position + gl_in[1].gl_Position + gl_in[2].gl_Position)/3;
	  v3 = (gl_in[0].gl_Position + gl_in[2].gl_Position*2)/3;
	  exColor = vec4(0,0,1,1);
	  break;
  	case 3:
	  v1 = (gl_in[0].gl_Position + gl_in[1].gl_Position*2)/3;
	  v2 = gl_in[1].gl_Position;
	  v3 = (gl_in[1].gl_Position*2 + gl_in[2].gl_Position)/3;
	  exColor = vec4(1,1,0,1);
	  break;
  	case 4:
	  v1 = (gl_in[0].gl_Position + gl_in[1].gl_Position + gl_in[2].gl_Position)/3;
	  v2 = (gl_in[1].gl_Position*2 + gl_in[2].gl_Position)/3;
	  v3 = (gl_in[1].gl_Position + gl_in[2].gl_Position*2)/3;
	  exColor = vec4(1,0,1,1);
	  break;
  	case 5:
	  v1 = (gl_in[0].gl_Position + gl_in[2].gl_Position*2)/3;
	  v2 = (gl_in[1].gl_Position + gl_in[2].gl_Position*2)/3;
	  v3 = gl_in[2].gl_Position;
	  exColor = vec4(0,1,1,1);
	  break;
  }
  
    gl_Position = v1;
    EmitVertex();
    gl_Position = v2;
    EmitVertex();
    gl_Position = v3;
    EmitVertex();

    EndPrimitive();
}
